#include <alloc.h>
#include <conio.h>
#include <stdio.h>


typedef struct
	{
	char Nume[20];
	char Tel[12];
	int Ord;
	} Info;

struct Nod
	{
	Info Date;
	Nod* Urm;
	};

struct Lista
	{
	int Lungime;
	struct Nod *Prim, *Curent, *Ultim;
	};

int Creare (struct Lista *ListaPtr);
int TestVida (struct Lista *ListaPtr);
int Primul (struct Lista *ListaPtr);
int Ultimul (struct Lista *ListaPtr);
int Lungime (struct Lista *ListaPtr);
int Inceput (struct Lista *ListaPtr);
int Sfarsit (struct Lista *ListaPtr);
int Precedent (struct Lista *ListaPtr);
int Pozitionare (struct Lista *ListaPtr, int Pozitie);
void AdaugaSfarsit (struct Lista *ListaPtr, Info Nou);
void AdaugaDreapta (struct Lista *ListaPtr, Info Nou);
int Stergere (struct Lista *ListaPtr);
int PermDreapta (struct Lista *ListaPtr);
void Ordonare (struct Lista *ListaPtr);
void Afisare (struct Lista *ListaPtr);
void AfisareMeniu ();
void InDatePers (struct Lista *ListaPtr, Info InfoInreg);

char c;
struct Lista *ListaTel;
Info InfoPers;
int Poz;


int Creare (struct Lista *ListaPtr)
	{
	ListaPtr->Prim=(Nod*)malloc(sizeof(struct Nod));
	if (!ListaPtr->Prim) return 0;
	ListaPtr->Ultim=(Nod*)malloc(sizeof(struct Nod));
	if (!ListaPtr->Ultim) return 0;
	ListaPtr->Prim->Urm=ListaPtr->Ultim;
	ListaPtr->Ultim->Urm=NULL;
	ListaPtr->Lungime=0;
	ListaPtr->Curent=ListaPtr->Prim;
	return 1;
	}

int TestVida (struct Lista *ListaPtr)
	{
	return ListaPtr->Lungime==0;
	}

int Primul (struct Lista *ListaPtr)
	{
	return (ListaPtr->Prim->Urm==ListaPtr->Curent)&&(!TestVida(ListaPtr));
	}

int Ultimul (struct Lista *ListaPtr)
	{
	return (ListaPtr->Curent->Urm==ListaPtr->Ultim)&&(!TestVida(ListaPtr));
	}

int Lungime (struct Lista *ListaPtr)
	{
	return ListaPtr->Lungime;
	}

int Inceput (struct Lista *ListaPtr)
	{
	if (TestVida(ListaPtr)) return 0;
	else
		{
		ListaPtr->Curent=ListaPtr->Prim->Urm;
		return 1;
		}
	}

int Sfarsit (struct Lista *ListaPtr)
	{
	if (TestVida(ListaPtr)) return 0;
	else
		{
		ListaPtr->Curent=ListaPtr->Ultim;
		if (Precedent(ListaPtr)) return 1;
		else return 0;
		}
	}

int Urmator (struct Lista *ListaPtr)
	{
	if (TestVida(ListaPtr)) return 0;
	else
		{
		if (ListaPtr->Curent->Urm!=ListaPtr->Ultim)
			{
			ListaPtr->Curent=ListaPtr->Curent->Urm;
			return 1;
			}
		else return 0;
		}
	}

int Precedent (struct Lista *ListaPtr)
	{
	struct Nod *Temp;
	if (ListaPtr->Lungime==0) return 0;
	if (ListaPtr->Lungime==1)
		{
		ListaPtr->Curent=ListaPtr->Prim->Urm;
		return 0;
		}
	Temp=ListaPtr->Curent;
	ListaPtr->Curent=ListaPtr->Prim;
	if (Temp==ListaPtr->Prim) return 0;
	else
		{
		while (ListaPtr->Curent->Urm!=Temp && Urmator(ListaPtr));
		return 1;
		}
	}

int Pozitionare (struct Lista *ListaPtr, int Pozitie)
	{
int l;
     l=Lungime(ListaTel);

	if (Inceput(ListaPtr))
		{
		do
		{
		if(ListaPtr->Curent->Date.Ord==Pozitie) return(1);
		Urmator(ListaPtr);
		l--;
		}
		while (l>0);
		return 0;
		}
		else return 0;
	}

void AdaugaSfarsit (struct Lista *ListaPtr, Info Nou)
	{
	struct Nod *Elem;
	Sfarsit (ListaPtr);
	Elem=(Nod*)malloc(sizeof(struct Nod));
	Elem->Urm=ListaPtr->Ultim;
	Elem->Date=Nou;
	ListaPtr->Curent->Urm=Elem;
	ListaPtr->Curent=Elem;
	ListaPtr->Lungime++;
	}

void AdaugaDreapta (struct Lista *ListaPtr, Info Nou)
	{
	struct Nod *Elem;
	Elem=(Nod*)malloc(sizeof(struct Nod));
	Elem->Urm=ListaPtr->Curent->Urm;
	Elem->Date=Nou;
	ListaPtr->Curent->Urm=Elem;
	ListaPtr->Lungime++;
	}

int Stergere (struct Lista *ListaPtr)
	{
	struct Nod *Elem;
	if (Lungime(ListaPtr))
		{
		Precedent(ListaPtr);
		Elem=ListaPtr->Curent->Urm;
		ListaPtr->Curent->Urm=Elem->Urm;
		free(Elem);
		ListaPtr->Lungime--;
		return 1;
		}
	else return 0;
	}

int PermDreapta (struct Lista *ListaPtr)
	{
	if (ListaPtr->Lungime>1)
		{
		struct Nod *Temp1=ListaPtr->Curent, *Temp2=ListaPtr->Curent->Urm;
		ListaPtr->Curent->Urm=ListaPtr->Curent->Urm->Urm;
		if (Precedent(ListaPtr)) {}
		ListaPtr->Curent->Urm=Temp2;
		Temp2->Urm=Temp1;
		ListaPtr->Curent=Temp1;
		return 1;
		}
	else return 0;
	}

void Ordonare (struct Lista *ListaPtr)
	{
	int i,j;
	if (Inceput(ListaPtr))
		for (i=1;i<Lungime(ListaPtr);i++)
			{
			if (Inceput(ListaPtr))
				for (j=i;j<Lungime(ListaPtr);j++)
				{
				if (ListaPtr->Curent->Date.Ord>ListaPtr->Curent->Urm->Date.Ord)
				PermDreapta(ListaPtr);
				else Urmator(ListaPtr);
				}
			}
	}

void Afisare(struct Lista *ListaPtr)
	{
	clrscr();
	printf ("Lista contine elementele:\n");
	if (Inceput(ListaPtr))
		{
		do      {
			printf("%d  ",ListaPtr->Curent->Date.Ord);
			printf("Nume: %s, Telefon: %s\n",ListaPtr->Curent->Date.Nume,
			ListaPtr->Curent->Date.Tel);
			}
			while (Urmator(ListaPtr));
			printf("Lista are %d abonati.", Lungime(ListaPtr));
			}
	else printf("Lista este vida\n");
	}

void AfisareMeniu(void)
	{
	clrscr();
	gotoxy(20,10);
	printf("1.Creare lista - C");
	gotoxy(20,11);
	printf("2.Adaugare la lista - A");
	gotoxy(20,12);
	printf("3.Stergere din lista - S");
	gotoxy(20,13);
	printf("4.Ordonare lista - O");
	gotoxy(20,14);
	printf("5.Printare lista - P");
	gotoxy(20,15);
	printf("6.Final program -F");
	}


void InDatePers (struct Lista *ListaPtr, Info InfoInreg)
	{
	clrscr();
	printf("Introduceti numele persoanei\n");
	fflush(NULL);
	gets (InfoInreg.Nume);
	printf("Introduceti telefonul persoanei\n");
	fflush(NULL);
	gets(InfoInreg.Tel);
	printf("Introduceti numarul de ordine\n");
	fflush(NULL);
	scanf ("%d", &InfoInreg.Ord);
	AdaugaSfarsit (ListaPtr, InfoInreg);
	}

void main(void)
{
		do
		{
			AfisareMeniu();
			c=getch();
			switch(c)
				{
				case '1':
				case 'c':
				case 'C':
					Creare(ListaTel);
					clrscr();
					printf("Lista a fost creata!");
					getch();
					break;
				case '2':
				case 'a':
				case 'A':
					InDatePers(ListaTel, InfoPers);
					break;
				case '3':
				case 's':
				case 'S':
					clrscr();
					printf("Numarul de ordine : ");
					scanf("%d",&Poz);
					if(Pozitionare (ListaTel,Poz))
					{
					Stergere (ListaTel);
					} else
					{
					printf("Elementul nu exista!");
					getch();
					break;
					}
					clrscr();
					printf("Elementul a fost sters!");
					getch();
					break;
				case '4':
				case 'o':
				case 'O':
					Ordonare(ListaTel);
					clrscr();
					printf("Lista a fost ordonata!");
					getch();
					break;
				case '5':
				case 'p':
				case 'P':
					Afisare(ListaTel);
					getch();
					break;
				case '6':
				case 'f':
				case 'F':
					clrscr();
					printf("Program terminat!");
					break;
				default:
					clrscr();
					printf("Optiune grsita!\n");
					getch();
					break;
				}
			}
		while ((c!='6') && (c!='f') && (c!='F'));
	}


